// Borrowed from Dominic Tarr's ubelt project:
// https://github.com/dominictarr/ubelt/blob/master/async.js

function compose () {
  var funx = [].slice.call(arguments)
  if(funx.length <= 1)
    return funx[0]
  var f1 = funx.shift()
  var f2 = funx.shift()
  
  funx.unshift(function () {
    var args = [].slice.call(arguments)
    var callback = args.pop()
    args.push(function () {
      var args = [].slice.call(arguments)
      args.push(callback)    
      f2.apply(_this, args)   
    })
    var _this = this;
    f1.apply(_this, args)   
  })
  return compose.apply(null, funx)
}

module.exports = compose;